; find out hardware map
HWN I
:query_loop
SUB I, 1
HWQ I
IFE B, 0x7349
  IFE A, 0xf615
    SET [monitor_n], I
IFE B, 0x30cf
  IFE A, 0x7406
    SET [keyboard_n], I
IFE B, 0x12d0
  IFE A, 0xb402
    SET [clock_n], I
IFN I, 0
  SET PC, query_loop

; set up monitor
SET A, 0
SET B, 0x8000
HWI [monitor_n]
SET A, 1
SET B, 0x9000
HWI [monitor_n]
; blue border
SET A, 3
SET B, 0x1
HWI [monitor_n]

; make font
SET I, 0
:font_loop
SET A, I
SET C, 0
SET J, 8
:bit_loop
SHL C, 2
IFC A, 0x80
  SET PC, bit_loop_it
BOR C, 0x3
:bit_loop_it
SHL A, 1
SUB J, 1
IFG J, 0
  SET PC, bit_loop
SET A, C
AND C, 0xff
SET B, C
SHL C, 8
BOR B, C
SET J, I
SHL J, 1
SET [0x9000+J], B
SHR A, 8
SET B, A
SHL A, 8
BOR B, A
SET [0x9001+J], B
ADD I, 1
IFL I, 0x80
  SET PC, font_loop

; draw to back buffer first
SET Z, 0x8000

SET PC, end_pixels_template


; puts a pixel to location (I,J) using screen map at Z
:putpixel
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET PUSH, X
SET PUSH, Y
SET PUSH, Z
; character coords:
SET X, I
SET Y, J
SHR X, 1
SHR Y, 2
SHL Y, 5
ADD X, Y
ADD Z, X
; find out character index
AND I, 0x1
AND J, 0x3
SET A, 1
SHL A, J
SHL I, 2
SHL A, I

SET B, [Z]
BOR A, 0xf000
IFB A, 0x80
  SET PC, putpixel_haslastpixel
SET PC, putpixel_nolastpixel
:putpixel_haslastpixel
IFC B, 0x0f00
  XOR B, 0xff7f
AND B, 0x0fff
SET PC, putpixel_draw
:putpixel_nolastpixel
IFB B, 0x0f00
  SET PC, putpixel_oldlastpixel
BOR B, A
SET PC, putpixel_draw
:putpixel_oldlastpixel
XOR A, 0xff7f
AND B, A
SET PC, putpixel_draw
:putpixel_draw
SET [Z], B
SET Z, POP
SET Y, POP
SET X, POP
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; draws a line from (I,J) to (X,Y) using screen map at Z
:drawline
SET PUSH, A
SET PUSH, B
SET PUSH, C
SET PUSH, I
SET PUSH, J
SET PUSH, X
SET PUSH, Y

; check if line is "flat" or "steep"
; A = X - I
SET A, X
SUB A, I
; B = Y - J
SET B, Y
SUB B, J
; X = |A|
SET PUSH, A
JSR abs
SET X, A
; Y = |B|
SET A, B
JSR abs
SET Y, A
SET A, POP
:drawline_skipabs
IFG Y, X
  SET PC, drawline_vert

:drawline_hori
; make sure that A>=0
IFA A, 0
  SET PC, drawline_skipxswap
JSR neg
SET PUSH, A
SET A, B
JSR neg
SET B, A
SET A, POP
; put X,Y values into I,J
SET J, POP  ; last pushed was Y
SET I, POP  ; before that was X
SET PUSH, I  ; restore stack
SET PUSH, J  ; restore stack
:drawline_skipxswap
; C = A/2
SET C, A
ASR C, 1
SET X, -1
:drawline_h_loop
ADD X, 1
SET Y, X
MLI Y, B
ADD Y, C  ; bias against div flooring
DVI Y, A
SET PUSH, I
SET PUSH, J
ADD I, X
ADD J, Y
JSR putpixel
SET J, POP
SET I, POP
IFN X, A
  SET PC, drawline_h_loop
SET PC, drawline_end

:drawline_vert
; make sure that B>=0
IFA B, 0
  SET PC, drawline_skipyswap
JSR neg
SET PUSH, A
SET A, B
JSR neg
SET B, A
SET A, POP
; put X,Y values into I,J
SET J, POP  ; last pushed was Y
SET I, POP  ; before that was X
SET PUSH, I  ; restore stack
SET PUSH, J  ; restore stack
:drawline_skipyswap
; C = B/2
SET C, B
ASR C, 1
SET Y, -1
:drawline_v_loop
ADD Y, 1
SET X, Y
MLI X, A
ADD X, C  ; bias against div flooring
DVI X, B
SET PUSH, I
SET PUSH, J
ADD I, X
ADD J, Y
JSR putpixel
SET J, POP
SET I, POP
IFN Y, B
  SET PC, drawline_v_loop

:drawline_end
SET Y, POP
SET X, POP
SET J, POP
SET I, POP
SET C, POP
SET B, POP
SET A, POP
SET PC, POP


; clear screen mapped to Z
:clearscr
SET PUSH, I
SET PUSH, Z
SET I, Z
ADD Z, 0x180
:clearscr_loop
SET [I], 0
ADD I, 1
IFL I, Z
  SET PC, clearscr_loop
SET Z, POP
SET I, POP
SET PC, POP


; switch to other screen buffer in Z (0x8000 <-> 0x8200) and clear new screen
:flipscr
SET PUSH, A
SET PUSH, B
SET A, 0
SET B, Z
HWI [monitor_n]
XOR Z, 0x0200
JSR clearscr
SET B, POP
SET A, POP
SET PC, POP


; sine function; input and return value in A
:sine
SET PUSH, B
AND A, 0x1f
IFB A, 0x8
  XOR A, 0xf
SET B, A
AND B, 0x7
SET B, [sintable+B]
SHR B, 1
IFC A, 0x10
  SET PC, sine_end
; make value negative
XOR B, 0xffff
ADD B, 1
:sine_end
SET A, B
SET B, POP
SET PC, POP


; unary minus; input and return value in A
:neg
XOR A, 0xffff
ADD A, 1
SET PC, POP


; abs function; input and return value in A
:abs
IFA A, 0
  SET PC, abs_skip
XOR A, 0xffff
ADD A, 1
:abs_skip
SET PC, POP


:monitor_n
DAT 0
:keyboard_n
DAT 0
:clock_n
DAT 0

:sintable
DAT 0x0000, 0x31f1, 0x61f8, 0x8e3a, 0xb505, 0xd4db, 0xec83, 0xfb15

:end_pixels_template
