; find out hardware map
HWN I
:query_loop
SUB I, 1
HWQ I
IFE B, 0x7349
  IFE A, 0xf615
    SET [monitor_n], I
IFE B, 0x30cf
  IFE A, 0x7406
    SET [keyboard_n], I
IFN I, 0
  SET PC, query_loop

; set up monitor
SET A, 0
SET B, 0x8000
HWI [monitor_n]


; draw upper left box
SET A, 0x8000
:draw_loop
IFG A, 0x8080
  SET PC, draw_end
SET [A], 0x6000
ADD A, 1
SET B, A
AND B, 0x001f
IFG B, 0x0010
  ADD A, 0x000f
SET PC, draw_loop
:draw_end
; print text
SET A, info_text
SET B, 0x6000
SET I, 0
SET J, 0
JSR putstr

; initialize registers
SET C, 0x0000  ; flags (damping)
SET I, 0x1000  ; position
SET X, 0x0000  ; speed
SET Z, 0x9000  ; input buffer

:main_loop
; delete last pos
;SET [0x8000+A], 0x0000
JSR scroll
; draw pos
SET A, I
DIV A, 5461  ; reduce range from 2^16 to 12
SHL A, 5
SET [0x801f+A], 0x0007
; calculate new pos
JSR step

SET PUSH, A
SET PUSH, I

SET I, POP
SET A, POP
;JSR delay

; check input
SET A, [Z]
IFE A, 0
  SET PC, i0
; got input; progress input buffer pointer
SET [Z], 0
ADD Z, 1
AND Z, 0x900f
; check for space (reset spring)
IFN A, 0x20
  SET PC, i1
SET I, 0x1000
SET X, 0
:i1
; check for 'd' (toggle damping)
IFN A, 0x64
  SET PC, i2
XOR C, 0x0001
; update info panel:
SET [0x800d], 0x604E
IFB C, 0x0001
  SET [0x800d], 0x6059
:i2
:i0
SET PC, main_loop


:step
SET PUSH, A
; position:
SET A, I
; distance from resing position:
SUB A, 0x8000
; save sign:
SET B, A
; reduce force:
SHR A, 2
IFB B, 0x8000
  BOR A, 0xc000
; apply force to speed:
SUB X, A

SET A, X
; save sign:
SET B, A
; reduce force further:
SHR A, 5
IFB B, 0x8000
  BOR A, 0xf800
; damping:
IFB C, 0x0001
  SUB X, A

; apply speed to position:
ADD I, X
SET A, POP
SET PC, POP


:delay
SET PUSH, A
SET A, 0x0800
:delay_loop
SUB A, 1
IFE O, 0
  SET PC, delay_loop
SET A, POP
SET PC, POP


; print hexadecimal number A to location I
:printhex
SET PUSH, A
SET PUSH, B
SET PUSH, I
SET PUSH, J
SET J, I
SUB J, 1
ADD I, 3
:printhex_l1
SET B, A
AND B, 0x0f
IFG B, 9
  ADD B, 7
ADD B, 0x30
SET [0x8000+I], B
SHR A, 4
SUB I, 1
IFN I, J
  SET PC, printhex_l1
SET J, POP
SET I, POP
SET B, POP
SET A, POP
SET PC, POP


; scrolls video memory to the left by one, leaving an upper left area alone
:scroll
SET PUSH, A
SET PUSH, B
SET PUSH, C
SET A, 0x8000
:scroll_loop
IFG A, 0x8060
  SET PC, scroll_l1
SET C, A
AND C, 0x001f
IFG 0x0010, C
  ADD A, 0x0010
:scroll_l1
SET C, [1+A]
BOR C, 0x0300
SET [A], C
; check for last column (make it 0)
SET B, A
ADD B, 1
AND B, 0x1f
IFE B, 0
  SET [A], 0

ADD A, 1
IFG 0x8180, A
  SET PC, scroll_loop

SET C, POP
SET B, POP
SET A, POP
SET PC, POP


; prints zero-terminated string starting at [A] to screen location (I,J) using
; color information in high 8 bits of B
:putstr
SET PUSH, A
SET PUSH, B
SET PUSH, C
SET PUSH, I
SET PUSH, J

; calculate memory location:
SHL J, 5
ADD J, 0x8000
ADD I, J
:putstr_loop
SET C, [A]
IFE C, 0
  SET PC, putstr_end
BOR C, B
SET [I], C
ADD A, 1
ADD I, 1
SET PC, putstr_loop

:putstr_end
SET J, POP
SET I, POP
SET C, POP
SET B, POP
SET A, POP
SET PC, POP


:info_text
DAT "Damping (d): N", 0


:monitor_n
DAT 0
:keyboard_n
DAT 0
